/*
 * uart_send.h
 *
 *  Created on: 20241119
 *      Author: psx
 */

#ifndef APP_INC_UART_SEND_H_
#define APP_INC_UART_SEND_H_

#include "uart_dev.h"

#define RS485_MAX_PACK_DATA_LEN  60

/* ָ뷽ʽΪ1ֽ */
#pragma pack(push,1)

typedef struct _send_data_info{
    device_handle device;
    uint8_t dataState;          //ݵ״̬1ݣ0
    uint8_t dataLen;            //ݳ
    uint8_t Counter;            //Ѿ͵ĳ
    uint8_t *data;              //ݵ
}send_data_info;

typedef struct _uart_send_info {
    uint8_t insertState;                    //ָܷʾ0ܲ
    uint8_t sendStateGw:1;                  //ָܷʾ1Ҫͣ0Ҫ
    uint8_t sendStateBat:1;                 //ָܷʾ
    uint8_t sendOverStateGw:1;              //ָʾ1ɣ0
    uint8_t sendOverStateBat:1;             //ָʾ
    uint8_t GwState:1;                      //ͨ485߿״̬1У0æ
    uint8_t idleStateGw:1;                  //ͨſ״̬1ûݵ0ݵ
    uint8_t BatState:1;                     //ͨ485߿״̬
    uint8_t idleStateBat:1;                 //ͨſ״̬
//    uint8_t sendStateGw;                  //ָܷʾ1Ҫͣ0Ҫ
//    uint8_t sendStateBat;                 //ָܷʾ
//    uint8_t sendOverStateGw;              //ָʾ1ɣ0
//    uint8_t sendOverStateBat;             //ָʾ
//    uint8_t GwState;                      //ͨ485߿״̬1У0æ
//    uint8_t idleStateGw;                  //ͨſ״̬1ûݵ0ݵ
//    uint8_t BatState;                     //ͨ485߿״̬
//    uint8_t idleStateBat;                 //ͨſ״̬
    send_data_info *insertData;             //ָͨд
    send_data_info *sendDataGw;             //ָͨ뷢
    send_data_info *sendDataBat;            //ָͨ뷢
    send_data_info data1;                   //ݵĵ1λ
    send_data_info data2;                   //ݵĵ2λ
    send_data_info data3;                   //ݵĵ3λ
}uart_send_info;
/* ָĬϵĶ */
#pragma pack(pop)

extern uart_send_info uart_send;

void send_init(void);
void check_sendState(void);
void uart_interruptSend(device_handle device, uint8_t buff[], uint8_t len);
void uartDMA_Init(device_handle device, uint8_t buff[], uint8_t len);

#endif /* APP_INC_UART_SEND_H_ */
